# SBL for Multiple Parameterized Dictionaries

This repository contains the python-code used in [1].

Included are (i) the code for the proposed sparse Bayesian learning (SBL)-based algorithm, (ii) the code for the newtonized orthogonal matching pursuit (NOMP) algorithm [2] used for comparison, (iii) additional files such as for the generalized subpattern assignment (OSPA) metric [3].

The repositor contains three demo examples (````example_<name>.py````). The script __example_crossing.py__ reproduces Figure 2 from [1].

### Repository structure:

    |- pySBL/pySBL.py     Code for the proposed algorithm
    |- pyOMP/pyOMP.py     Implementation of the NOMP method for comparison
    |- dictionary_functions.py    Implementation of the (parameterized) dictionary functions
    |- gopsa.py           Implementation of the OSPA used to evaluate the results.
    |- example_radar.py   Demo example with a single radar comparing SBL and OMP
    |- example_multiradar.py      Demo Example applying SBL to multiple radars
    \  example_crossing.py        Demo example of two crossing targets (Fig. 2)


The code was tested using python 3.13 and numpy 2.2.3. The full spec of the miniconda environment is found in python_env.txt

## References

[1] Moederl J., Westerkam, A. M., Venus, A. and Leitinger, E., "A Block-Sparse Bayesian Learning Algorithm with Dictionary Parameter Estimation for Multi-Sensor Data Fusion", submitted to the _IEEE 28th International Conference on Information Fusion_, Rio de Janeiro, Brazil, Jul 7-11, 2025. 

[2] B. Mamandipoor, D. Ramasamy, and U. Madhow, "Newtonized orthogonal matching pursuit: Frequency estimation over the continuum," _IEEE Trans. Signal Process.,_ vol. 64, no. 19, pp. 5066-5081, Oct. 2016.

[3] A. S. Rahmathullah, A. F. Garcia-Fernandez, and L. Svensson,"Generalized optimal sub-pattern assignment metric," in _20th Int. Conf. Inf. Fusion_, Xi'an, China, Jul. 10-13, 2017.